// Generated by CoffeeScript 1.10.0
(function() {
  var _, ast;

  _ = require("underscore");

  module.exports = ast = {

    /*
      filters: an array of filter functions
      example:
      ast.traverse esprima.parse(src, opt), (node)->
     */
    traverse: function(node, filters, cb) {
      var filter;
      if (_(filters).isFunction()) {
        cb = filters;
        filters = [];
      }
      if (filters.length === 0) {
        filter = function(node) {
          return true;
        };
      } else {
        filter = function(node) {
          var f;
          return ((function() {
            var i, len, results;
            results = [];
            for (i = 0, len = filters.length; i < len; i++) {
              f = filters[i];
              if (f(node)) {
                results.push(f);
              }
            }
            return results;
          })()).length > 0;
        };
      }
      return ast._traverse(node, filter, cb);
    },
    _traverse: function(node, filter, cb) {
      var i, key, len, n, results, results1;
      if (Array.isArray(node)) {
        results = [];
        for (i = 0, len = node.length; i < len; i++) {
          n = node[i];
          results.push(ast._traverse(n, filter, cb));
        }
        return results;
      } else if (node && typeof node === 'object') {
        if (filter(node)) {
          cb(node);
        }
        results1 = [];
        for (key in node) {
          n = node[key];
          if (n) {
            results1.push(ast._traverse(n, filter, cb));
          }
        }
        return results1;
      } else {
        if (filter(node)) {
          return cb(node);
        }
      }
    },
    isFunc: function(node, name) {
      return node && node.callee && node.type === 'CallExpression' && node.callee.type === 'Identifier' && ((!name) || node.callee.name === name);
    },
    isRequire: function(node) {
      return ast.isFunc(node, 'require');
    }
  };

}).call(this);

//# sourceMappingURL=ast.js.map
