// Generated by CoffeeScript 1.10.0

/*
  The "code fusion", generates one working js from commonJs require modules.

  1. supports circular dependency: as long as the source works in nodejs, so should the generated code
  2. original source code is not modified.  Instead code is injected to simulate commonJS require.
  3. recognizes nodejs native components "*.node"
  4. recursive fuse:  fused code can be fused, minified (or not), required and then fused again.

  To learn more, look at generated code.
 */

(function() {
  var _, fs, fuse, log, path, sourceMap,
    indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

  path = require("path");

  fs = require("fs");

  _ = require("underscore");

  log = require("lawg");

  sourceMap = require("source-map");

  module.exports = fuse = {
    generate: function(arg) {
      var asLib, baseDir, binaryUnits, code, coreUnits, fileUnits, generateSm, i, includePackage, k, key, l, len, len1, len2, lmapcode, m, moduleName, oldunit, packages, pkginfo, prependCode, r, sCoreRequires, smMatch, smRegex, src, unit, units;
      baseDir = arg.baseDir, moduleName = arg.moduleName, units = arg.units, asLib = arg.asLib, generateSm = arg.generateSm, includePackage = arg.includePackage, prependCode = arg.prependCode;
      coreUnits = (function() {
        var k, len, results;
        results = [];
        for (k = 0, len = units.length; k < len; k++) {
          unit = units[k];
          if (unit.isCore) {
            results.push(unit);
          }
        }
        return results;
      })();
      binaryUnits = (function() {
        var k, len, results;
        results = [];
        for (k = 0, len = units.length; k < len; k++) {
          unit = units[k];
          if (unit.isBinary) {
            results.push(unit);
          }
        }
        return results;
      })();
      fileUnits = (function() {
        var k, len, results;
        results = [];
        for (k = 0, len = units.length; k < len; k++) {
          unit = units[k];
          if (!unit.isCore && !unit.isBinary) {
            results.push(unit);
          }
        }
        return results;
      })();
      fuse._makeKeys(fileUnits.concat(binaryUnits));
      for (k = 0, len = coreUnits.length; k < len; k++) {
        unit = coreUnits[k];
        unit.key = unit.fpath;
      }
      sCoreRequires = ((function() {
        var l, len1, results;
        results = [];
        for (l = 0, len1 = coreUnits.length; l < len1; l++) {
          unit = coreUnits[l];
          results.push("__m['" + unit.key + "'] = {\n  sts  : 1,\n  mod  : {exports: __m.__sr('" + unit.key + "')}\n};");
        }
        return results;
      })()).join('\n');
      (function(_this) {
        return (function() {
          var binName, l, len1, mem, results;
          mem = {};
          results = [];
          for (l = 0, len1 = binaryUnits.length; l < len1; l++) {
            unit = binaryUnits[l];
            binName = path.basename(unit.fpath);
            while (indexOf.call(mem, binName) >= 0) {
              binName = '_' + binName;
            }
            unit.binName = binName;
            results.push(sCoreRequires += "__m['" + unit.key + "'] = {\n  sts  : null,\n  mod  : {exports: {}},\n  load : function() { return (__m['" + unit.key + "'].mod.exports = __m.__sr('./" + binName + "')); }\n};");
          }
          return results;
        });
      })(this)();
      code = prependCode + "\n(function(run, root) {\n  var ret = run.bind(root)();\n  if ('" + moduleName + "') root['" + moduleName + "'] = ret;\n  if (\"object\" == typeof exports && \"undefined\" != typeof module)\n    module.exports = ret;\n}(function() {\nvar __m = {};\nif (typeof require === 'undefined') __m.__sr = function() {};\nelse __m.__sr = require;\n__m.__r = function(key) {\n  var m = __m[key];\n  if (m.sts === null) m.load.call();\n  return m.mod.exports;\n};\n" + sCoreRequires;
      smRegex = /\/\/# sourceMappingURL=([_\w\-\.\~]+)/;
      for (i = l = 0, len1 = fileUnits.length; l < len1; i = ++l) {
        unit = fileUnits[i];
        i = i + 1;
        smMatch = smRegex.exec(unit.src);
        if (smMatch) {
          unit.src = src = unit.src.replace("//# sourceMappingURL=", "// sourceMappingURL=");
          unit.sm = {
            url: smMatch[1]
          };
        } else {
          src = unit.src;
        }
        if (path.extname(unit.fpath) === ".json") {
          code += "__m['" + unit.key + "'] = {\n  sts: 1,\n  mod: { exports:";
          if (generateSm) {
            unit.smline = fuse._lc(code);
          }
          code += src;
          code += "}};\n";
        } else {
          lmapcode = ((function() {
            var len2, m, ref, results;
            ref = unit.requires;
            results = [];
            for (m = 0, len2 = ref.length; m < len2; m++) {
              r = ref[m];
              results.push("        '" + r.name + "': '" + r.unit.key + "'");
            }
            return results;
          })()).join(",\n");
          pkginfo = unit["package"] ? unit["package"].name + "@" + (unit["package"].version || '') : "";
          pkginfo += "(" + (path.basename(unit.fpath)) + ")";
          code += "__m['" + unit.key + "'] = {\n  sts: null,\n  mod: { " + (unit["package"] && includePackage ? "package: " + (JSON.stringify(unit["package"])) + "," : "") + "\n    exports: {} },\n  load: (function() {\n    var module = __m['" + unit.key + "'].mod;\n    var exports = module.exports;\n    var require = function(name) {\n      var namemap = {\n" + lmapcode + "\n      }\n      var k = namemap[name];\n      return k ? __m.__r(k) : __m.__sr(name);\n    }\n    require.resolve = __m.__sr.resolve;\n    __m['" + unit.key + "'].sts = 0;\n//******** begin file " + pkginfo + " ************\n";
          if (generateSm) {
            unit.smline = fuse._lc(code);
          }
          code += src;
          code += "\n//******** end file " + pkginfo + "************\n    __m['" + unit.key + "'].sts = 1;\n  }).bind(this)\n};\n";
        }
      }
      if (asLib) {
        code += "return {\n";
        packages = {};
        for (m = 0, len2 = fileUnits.length; m < len2; m++) {
          unit = fileUnits[m];
          if (unit["package"]) {
            if (unit["package"].name in packages) {
              oldunit = packages[unit["package"].name];
              if (oldunit["package"].version !== unit["package"].version) {
                packages[oldunit["package"].name + "@" + oldunit["package"].version] = oldunit;
                packages[unit["package"].name + "@" + unit["package"].version] = unit;
              }
            } else {
              packages[unit["package"].name] = unit;
            }
          }
        }
        for (key in packages) {
          unit = packages[key];
          code += "'" + key + "':  __m.__r('" + unit.key + "'),\n";
        }
        code += "};\n";
      } else {
        code += "\nreturn __m.__r('" + (_(fileUnits).last().key) + "');\n";
      }
      code += "\n},this));";
      return [code, binaryUnits, generateSm ? fuse._generateSourceMap(baseDir, code, fileUnits) : null];
    },
    _generateSourceMap: function(baseDir, code, units) {
      var SourceMapGenerator, e, error, i, k, l, lc, len, len1, len2, len3, line, m, map, n, o, ref, ref1, ref2, ref3, s, sec, sections, sm, sp, srcfile, unit, unitDir, url;
      sections = [];
      for (k = 0, len = units.length; k < len; k++) {
        unit = units[k];
        unitDir = path.dirname(unit.fpath);
        if (unit.sm) {
          url = path.resolve(unitDir, unit.sm.url);
          try {
            sm = JSON.parse(fs.readFileSync(url));
          } catch (error) {
            e = error;
            log("Skipped invalid source map file " + (path.relative(baseDir, url)));
            continue;
          }
          if (sm.sections) {
            ref = sm.sections || [];
            for (i = l = 0, len1 = ref.length; l < len1; i = ++l) {
              sec = ref[i];
              sec.offset.line += unit.smline;
              ref1 = sec.map.sources;
              for (i = m = 0, len2 = ref1.length; m < len2; i = ++m) {
                s = ref1[i];
                sp = path.resolve(unitDir, s);
                sec.map.sources[i] = path.relative(baseDir, sp);
              }
            }
            sections.push.apply(sections, sm.sections);
          } else {
            ref2 = sm.sources;
            for (i = n = 0, len3 = ref2.length; n < len3; i = ++n) {
              s = ref2[i];
              sp = path.resolve(unitDir, s);
              sm.sources[i] = path.relative(baseDir, sp);
            }
            sections.push({
              offset: {
                line: unit.smline,
                column: 0
              },
              map: sm
            });
          }
        } else {
          SourceMapGenerator = sourceMap.SourceMapGenerator;
          srcfile = path.relative(baseDir, unit.fpath);
          map = new SourceMapGenerator({
            file: srcfile
          });
          lc = fuse._lc(unit.src);
          if (lc > 0) {
            for (line = o = 1, ref3 = lc; 1 <= ref3 ? o <= ref3 : o >= ref3; line = 1 <= ref3 ? ++o : --o) {
              map.addMapping({
                source: srcfile,
                original: {
                  line: line,
                  column: 0
                },
                generated: {
                  line: line,
                  column: 0
                }
              });
            }
          }
          sections.push({
            offset: {
              line: unit.smline,
              column: 0
            },
            map: map.toJSON()
          });
        }
      }
      if (sections.length === 0) {
        return null;
      } else {
        return {
          version: 3,
          file: '',
          sections: sections
        };
      }
    },
    _lc: function(str) {
      var c, i, k, ref;
      c = 0;
      for (i = k = 0, ref = str.length; 0 <= ref ? k < ref : k > ref; i = 0 <= ref ? ++k : --k) {
        if (str[i] === '\n') {
          c++;
        }
      }
      return c;
    },
    _makeKeys: function(units) {
      var c, i, k, len, results, unit;
      c = function(i) {
        var x;
        return ((function() {
          var k, ref, results;
          results = [];
          for (x = k = 0, ref = Math.floor(i / 26); 0 <= ref ? k <= ref : k >= ref; x = 0 <= ref ? ++k : --k) {
            results.push(i % 26);
          }
          return results;
        })()).reduce(function(r, j) {
          return r + String.fromCharCode('a'.charCodeAt(0) + j);
        }, '');
      };
      results = [];
      for (i = k = 0, len = units.length; k < len; i = ++k) {
        unit = units[i];
        results.push(unit.key = c(i));
      }
      return results;
    },
    _makeSensibleKeys: function(units) {
      var commonPrefix, k, len, pfix, results, unit;
      commonPrefix = function(s1, s2) {
        var i, k, ref;
        for (i = k = 0, ref = Math.min(s1.length, s2.length); 0 <= ref ? k < ref : k > ref; i = 0 <= ref ? ++k : --k) {
          if (s1[i] !== s2[i]) {
            break;
          }
        }
        if (s1.length < s2.length) {
          return s1.slice(0, i);
        } else {
          return s2.slice(0, i);
        }
      };
      pfix = units.slice(1).reduce((function(pfix, unit) {
        return commonPrefix(pfix, unit.fpath);
      }), units[0].fpath);
      pfix = pfix.replace(/[^\/\\]*$/, '');
      results = [];
      for (k = 0, len = units.length; k < len; k++) {
        unit = units[k];
        results.push(unit.key = unit.fpath.slice(pfix.length).replace(/\\/g, '/'));
      }
      return results;
    }
  };

}).call(this);

//# sourceMappingURL=fuse.js.map
